unit disp_coord2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  Tfdisp_coord = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Memo1: TMemo;
    BitBtn3: TBitBtn;
    procedure sortie(Sender: TObject);
    procedure initialise(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure copy_clipboard(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fdisp_coord: Tfdisp_coord;

implementation
 uses
   oemath,digicode;
{$R *.DFM}

procedure Tfdisp_coord.sortie(Sender: TObject);
//---------------------------------------------
begin
  if fileexists('coordonnees.txt') then deletefile('coordonnees.txt');
  fdisp_coord.visible:=false;
end;

procedure Tfdisp_coord.initialise(Sender: TObject);
//-------------------------------------------------
var
   s,s1                : string;
   c4                  : string[4];
   s2                  : string[2];
   i,j,k,i1,i2,i3,i4   : integer;
begin
  //listbox1.clear;
  memo1.clear;
  memo1.Lines[0]:='Coordinates';
  for i:=1 to nb_child do begin
    with child[i] do begin
      s1:=nom;
      traite_nom_atome(s1);
      c4:=copy(s1,1,4);
      if (length(c4) < 4)then for k:=length(c4)+1 to 4 do c4:=c4+' ';
      str(i:3,s1);
      s:=s1+' '+c4+' ';
      str(x:8:4,s1);
      s:=s+s1;
      str(y:8:4,s1);
      s:=s+s1;
      str(z:8:4,s1);
      s:=s+s1;
      j:=i;
      s2:=uppercase(child[i].element);
      if (s2 = 'DU')then begin
        i1:=0;
        i2:=0;
        i3:=0;
        i4:=0;
      end else
        code_positions(j,i1,i2,i3,i4);
      s:=s+' ('+s_pos[i1]+')('+inttostr(i1)+'_'+inttostr(i2)+inttostr(i3)+inttostr(i4)+')';
      memo1.lines.add(s);
    end;
  end;
end;

procedure Tfdisp_coord.BitBtn2Click(Sender: TObject);
//--------------------------------------------------
var
   CmdFile           : PChar;
   i                 : integer;
   nomf              : Textfile;
   //s1,s2             : string[4];
   s                 : string;
begin
   assignfile (nomf,repertoire_origine+'/coordonnees.txt');
   rewrite(nomf);
   if (nom_fichier_shelx <> '')then writeln(nomf,extractfilename(nom_fichier_shelx));
   if (nom_fichier_grt <> '')then writeln(nomf,extractfilename(nom_fichier_grt));
   for i:=0 to nb_child do begin
(*     with child[i] do begin
       s:=nom;
       traite_nom_atome(s);s:=trim(s);
       writeln(nomf,nom:4,' ',x:10:5,y:10:5,z:10:5); *)
       s:=memo1.lines[i];
       writeln(nomf,s);
    //end;
  end;
  closefile(nomf);
  CmdFile:='write.exe coordonnees.txt';
  i:=WinExec(CmdFile,5);
end;


procedure Tfdisp_coord.copy_clipboard(Sender: TObject);
//----------------------------------------------------
begin
  memo1.CopyToClipboard;
end;

end.
