unit fragment;

interface

Uses
  SysUtils, WinTypes, WinProcs, Messages,StdCtrls, dialogs, math;

//Procedure calc_fragment_motif;
Procedure calc_fragment_child;
procedure reset_motif;

implementation
{R+}

uses
  oemath;

type
tabfragment                                  = array[1..2000] of integer;

procedure reset_motif; //Restauration des atomes du motif
//--------------------
var i:integer;
begin
  for i:=1 to nb_motif_old do motif[i]:=motif_old[i];
  nb_motif:=nb_motif_old;
end;

(*
procedure compacte_liste_motif;
//-----------------------------
var
  atdel                : array [1..2000] of ^atomes;
  n,i                  : integer;
begin
  n:=0;
  for i:=1 to nb_motif do begin
    if (motif[i].nom <> '')then begin
      n:=n+1;
      new(atdel[n]);
      atdel[n]^:=motif[i];
    end;
  end;
  for i:=1 to n do motif[i]:=atdel[i]^ ;
  for i:=1 to n do dispose(atdel[i]);
  nb_motif:=n;
end;
*)

procedure purge_fragment(var frag: tabfragment; var pop:integer);
//-----------------------------------------------------------
var
  j,k,n : integer;
begin
    for j:=1 to pop-1 do begin
      if (frag[j] = 0)then continue;
      for k:=j+1 to pop do begin
        if (frag[k] = frag[j])then frag[k]:=0;
      end;
    end;
    n:=0;
    for j:=1 to pop do begin
      if (frag[j] = 0)then continue;
      n:=n+1;
      frag[n]:=frag[j];
    end;
    pop:=n;
end;
(*
Procedure calc_fragment_motif;
//---------------------------
type
  bi = record
    atome1, atome2 : integer;
  end;
var
   content       : array[1..200] of atomes;
   nb_content    : integer;
   paire           : array[1..2000] of bi;
   nb_paire        : integer;
   num_frag        : integer;
   pop_frag,frag   : tabfragment;
   ier1,ier2       : integer;

  pop                                         : integer;
  i,j,k,numero,ier                            : integer;
  nomf                                        : textfile;
  ii,jj,kk                                    : integer;
  x3,y3,z3,d,dx,dy,dz                         : double;

  x1,y1,z1,x2,y2,z2,xg,yg,zg,dmax,distance    : double;
  p_frag                                      : array[1..100] of integer;
  tableau                                     : array[1..100,1..100] of integer;
  ipos,numero_position,numero_fragment        : integer;
  i1,i2,j1,j2,k1,k2,l                         : integer;
  el1,el2                                     : string;
  ix,iy,iz,n                                 : integer;
  bet,r,r_trans,aux                           : matrice3;
  label 1;label 2;
begin
  nb_content:=0;
  //assignfile(nomf,'motif.esp');
  //rewrite(nomf);
  //writeln(nomf,'set de dpart');
  for i:=1 to nb_motif do begin
    with motif[i] do begin
      writeln(nomf,nom,i:3,'    ',x:10:5,y:10:5,z:10:5,beta[1]:10:5,beta[2]:10:5,
      beta[3]:10:5, beta[4]:10:5, beta[5]:10:5, beta[6]:10:5);
    end;
  end;
  writeln(nomf);

//Calcul des distances ==> paire
  nb_paire:=0;
  for i:=1 to nb_motif-1 do begin
    el1:=copy(motif[i].nom,1,2);traite_nom_element(el1);el1:=trim(el1);
    for j:=i+1 to nb_motif do begin
      el2:=copy(motif[j].nom,1,2);traite_nom_element(el2);el2:=trim(el2);
      for k:= 1 to nb_typ_liai do begin
        if ((tableau_liai[k].atome1 = el1) and (tableau_liai[k].atome2 = el2)) or
        ((tableau_liai[k].atome2 = el1) and (tableau_liai[k].atome1 = el2)) then
        begin
          dmax:=sqr(tableau_liai[k].distance);
          break;
        end;
      end;
      x1:=motif[i].x-motif[j].x;
      y1:=motif[i].y-motif[j].y;
      z1:=motif[i].z-motif[j].z;
      trfo2(x1,y1,z1,r20);
      distance:=x1*x1+y1*y1+z1*z1;
      if (distance <= dmax)then begin
        nb_paire:=nb_paire+1;
        paire[nb_paire].atome1:=i;
        paire[nb_paire].atome2:=j;
        //writeln(nomf,i,'-',j,' ',motif[i].nom,'-',motif[j].nom,sqrt(distance):10:3);
      end;
    end;
  end;

//Fragment 1
  nb_fragments:=0;
1: nb_fragments:=nb_fragments+1;
  pop:=0;
  pop:=1;
  frag[pop]:=paire[1].atome1;
  pop:=pop+1;
  frag[pop]:=paire[1].atome2;
  numero:=1;
  repeat
    for i:=2 to nb_paire do  begin
      if (paire[i].atome1 = frag[numero])then begin
        pop:=pop+1;
        frag[pop]:=paire[i].atome2;
      end;
      if (paire[i].atome2 = frag[numero])then begin
        pop:=pop+1;
        frag[pop]:=paire[i].atome1;
      end;
    end;
    purge_fragment(frag,pop);
    numero:=numero+1;
  until (numero > pop);

//Ecriture du fragment
  //for i:=1 to pop do writeln(nomf, frag[i]:3,' ',motif[frag[i]].nom);

//Purge des paires
  //writeln(nomf,'paires restantes');
  n:=0;
  for i:=1 to nb_paire do begin
    ier1:=0;
    ier2:=0;
    for j:=1 to pop do begin
      if (frag[j] = paire[i].atome1) then ier1:=1;
      if (frag[j] = paire[i].atome2) then ier2:=1;
    end;
    if (ier1 = 0)and (ier2 = 0)then begin
      n:=n+1;
      paire[n]:=paire[i];
      //writeln(nomf,paire[n].atome1,'-',paire[n].atome2);
    end;
  end;
  nb_paire:=n;
  //writeln(nomf,'Nb de paires restantes: ',n);

//purge du motif
  for i:=1 to pop do begin
    nb_content:=nb_content+1;
    content[nb_content]:=motif[frag[i]];
    content [nb_content].nbfrg:=nb_fragments;
    motif[frag[i]].nom:='';
  end;
  //compacte_liste_motif;
  //writeln(nomf,'Motif restant');
  for i:=1 to nb_motif do begin
    with(motif[i]) do begin
      writeln(nomf,nom,i:4,x:10:5,y:10:5,z:10:5);
    end;
  end;
//---------------------------------------------------------------------------
  if (nb_paire > 0)then goto 1;
//---------------------------------------------------------------------------
  compacte_liste_motif;
  if (nb_paire = 0) and (nb_motif > 0) then begin
    for i:=1 to nb_motif do begin
      nb_content:=nb_content+1;
      content[nb_content]:=motif[i];
      nb_fragments:=nb_fragments+1;
      content[nb_content].nbfrg:=nb_fragments;
    end;
  end;

//Restauration de motif
  nb_motif:=nb_content;
  for i:=1 to nb_motif do motif[i]:=content[i];
  writeln(nomf,'Finalement:');
  for i:=1 to nb_motif do begin
    with motif[i] do begin
      writeln(nomf,nom,' ',i:3,x:10:5,y:10:5,z:10:5,nbfrg:3);
    end;
  end;

//************************ Liaisons entre fragments *************************

  if (nb_fragments < 2)then begin
    //closefile(nomf);
    exit;
  end;
  for i:=1 to nb_fragments do begin
    p_frag[i]:=0;
    for j:=1 to nb_motif do begin
      if (motif[j].nbfrg = i)then begin
        p_frag[i]:=p_frag[i]+1;
        tableau[i,p_frag[i]]:=j;
      end;
    end;
  end;

  for i:=1 to nb_fragments do begin
    writeln(nomf,'Fragment ',i:2,' population : ',p_frag[i]:3);
    for j:=1 to p_frag[i] do writeln(nomf,motif[tableau[i,j]].nom);
  end;

//Fragment deb
  if (npos > 1) then begin
    for i1:=1 to nb_fragments-1 do begin
      for j1:=1 to p_frag[i1] do begin
        k1:=tableau[i1,j1];
        x1:=motif[k1].x;
        y1:=motif[k1].y;
        z1:=motif[k1].z;
        el1:=copy(motif[k1].nom,1,2);traite_nom_element(el1);el1:=trim(el1);
//Fragment fin
        numero_position:=0;
        for i2:= i1+1 to nb_fragments do begin
          for j2:=1 to p_frag[i2] do begin
            k2:=tableau[i2,j2];
            x2:=motif[k2].x;
            y2:=motif[k2].y;
            z2:=motif[k2].z;
            el2:=copy(motif[k2].nom,1,2);traite_nom_element(el2);el2:=trim(el2);
//Distance max de la liaison
            dmax:=0;
            for j:= 1 to nb_typ_liai do begin
              if ((tableau_liai[j].atome1 = el1) and (tableau_liai[j].atome2 = el2)) or
              ((tableau_liai[j].atome2 = el1) and (tableau_liai[j].atome1 = el2)) then
              begin
                dmax:=sqr(tableau_liai[j].distance);
                break;
              end;
            end;
            if (dmax = 0)then continue;
            //writeln(nomf,el1,'-',el2, 'distance: ',dmax:7:3);
//Oprateurs de symtrie et translations
            for ix:=-1 to 1 do begin
              dx:=ix;
              for iy:=-1 to 1 do begin
                dy:=iy;
                for iz:=-1 to 1 do begin
                  dz:=iz;
                  for ipos:=1 to npos do begin
                    x3:=x2*tp[ipos,1,1]+y2*tp[ipos,1,2]+z2*tp[ipos,1,3]+tp[ipos,1,4]+dx;
                    y3:=x2*tp[ipos,2,1]+y2*tp[ipos,2,2]+z2*tp[ipos,2,3]+tp[ipos,2,4]+dy;
                    z3:=x2*tp[ipos,3,1]+y2*tp[ipos,3,2]+z2*tp[ipos,3,3]+tp[ipos,3,4]+dz;
                    x3:=x3-x1;y3:=y3-y1;z3:=z3-z1;
                    trfo2(x3,y3,z3,r20);
                    distance:=sqr(x3)+sqr(y3)+sqr(z3);
                    if (distance <= dmax)then begin
                      numero_position:=ipos;
                      numero_fragment:=i2;
                      goto 2;
                    end;
                  end;
                end;
              end;
            end;
          end;
        end;
//Transformation du fragment 2 par les oprateurs de symtrie no numero_position
     2: if (numero_position > 0)then begin
          for i:=1 to p_frag[numero_fragment] do begin
            k:=tableau[numero_fragment,i];
            with motif[k] do begin
              ipos:=numero_position;
              x1:=x;y1:=y;z1:=z;
              x:=x1*tp[ipos,1,1]+y1*tp[ipos,1,2]+z1*tp[ipos,1,3]+tp[ipos,1,4]+dx;
              y:=x1*tp[ipos,2,1]+y1*tp[ipos,2,2]+z1*tp[ipos,2,3]+tp[ipos,2,4]+dy;
              z:=x1*tp[ipos,3,1]+y1*tp[ipos,3,2]+z1*tp[ipos,3,3]+tp[ipos,3,4]+dz;
              bet[1,1]:=beta[1];
              bet[2,2]:=beta[2];
              bet[3,3]:=beta[3];
              bet[1,2]:=beta[4];
              bet[1,3]:=beta[5];
              bet[2,3]:=beta[6];
              bet[2,1]:=bet[1,2];
              bet[3,1]:=bet[1,3];
              bet[3,2]:=bet[2,3];
              for l:=1 to 3 do begin
                for k:=1 to 3 do begin
                  r[l,k]:=tp[ipos,l,k];
                  r_trans[k,l]:=r[l,k];
                end;
              end;
              mat_mult(bet,r_trans,aux);
              mat_mult(r,aux,bet);
              beta[1]:=bet[1,1];
              beta[2]:=bet[2,2];
              beta[3]:=bet[3,3];
              beta[4]:=bet[1,2];
              beta[5]:=bet[1,3];
              beta[6]:=bet[2,3];
            end;
//*****************************************************************************
          end;
        end;
//*****************************************************************************
      end;
    end;
  end;
  //closefile(nomf);

end;

   *)
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

procedure compacte_liste_child;
//-----------------------------
var
  atdel                : array [1..2000] of ^atomes;
  n,i                  : integer;
begin
  n:=0;
  for i:=1 to nb_child do begin
    if (child[i].nom <> '')then begin
      n:=n+1;
      new(atdel[n]);
      atdel[n]^:=child[i];
    end;
  end;
  for i:=1 to n do child[i]:=atdel[i]^ ;
  for i:=1 to n do dispose(atdel[i]);
  nb_child:=n;
end;

Procedure calc_fragment_child;
//---------------------------
type
  bi = record
    atome1, atome2 : integer;
  end;
var
   content        : array[1..2000] of atomes;
   nb_content     : integer;
   paire           : array[1..2000] of bi;
   nb_paire        : integer;
   num_frag        : integer;
   pop_frag,frag   : tabfragment;
   ier1,ier2       : integer;

  pop                                         : integer;
  i,j,k,numero,ier                            : integer;
  //nomf                                        : textfile;
  x3,y3,z3,d,dx,dy,dz                                  : double;

  x1,y1,z1,x2,y2,z2,xg,yg,zg,dmax,distance    : double;
  ipos,numero_position,numero_fragment        : integer;
  el1,el2                                     : string;
  ix,iy,iz,n                         : integer;
  label 1;label 2;
begin
  nb_content:=0;
  assignfile(nomf,'child.esp');
  rewrite(nomf);
  writeln(nomf,'child de dpart');
  for i:=1 to nb_child do begin
    with child[i] do begin
      writeln(nomf,nom,i:3,'    ',x:10:5,y:10:5,z:10:5,beta[1]:10:5,beta[2]:10:5,
      beta[3]:10:5, beta[4]:10:5, beta[5]:10:5, beta[6]:10:5);
    end;
  end;
  writeln(nomf); 

//Calcul des distances ==> paire
  nb_paire:=0;
  for i:=1 to nb_child-1 do begin
    el1:=copy(child[i].nom,1,2);traite_nom_element(el1);el1:=trim(el1);
    for j:=i+1 to nb_child do begin
      el2:=copy(child[j].nom,1,2);traite_nom_element(el2);el2:=trim(el2);
      for k:= 1 to nb_typ_liai do begin
        if ((tableau_liai[k].atome1 = el1) and (tableau_liai[k].atome2 = el2)) or
        ((tableau_liai[k].atome2 = el1) and (tableau_liai[k].atome1 = el2)) then
        begin
          dmax:=sqr(tableau_liai[k].distance);
          break;
        end;
      end;
      x1:=child[i].x-child[j].x;
      y1:=child[i].y-child[j].y;
      z1:=child[i].z-child[j].z;
      trfo2(x1,y1,z1,r20);
      distance:=x1*x1+y1*y1+z1*z1;
      if (distance <= dmax)then begin
        nb_paire:=nb_paire+1;
        paire[nb_paire].atome1:=i;
        paire[nb_paire].atome2:=j;
        writeln(nomf,i:3,'-',j:3,'    ',child[i].nom,'-',child[j].nom,sqrt(distance):10:3);
      end;
    end;
  end;
  writeln(nomf,'Nb de paires: ',nb_paire:5);

//calcul des Fragments
  nb_fragments:=0;
1: nb_fragments:=nb_fragments+1;
  pop:=1;
  frag[pop]:=paire[1].atome1;
  pop:=pop+1;
  frag[pop]:=paire[1].atome2;
  numero:=1;
  repeat
    for i:=2 to nb_paire do  begin
      if (paire[i].atome1 = frag[numero])then begin
        pop:=pop+1;
        frag[pop]:=paire[i].atome2;
      end;
      if (paire[i].atome2 = frag[numero])then begin
        pop:=pop+1;
        frag[pop]:=paire[i].atome1;
      end;
    end;
    purge_fragment(frag,pop);
    numero:=numero+1;
  until (numero > pop);

//Ecriture du fragment
  writeln(nomf,'Fragment');
  for i:=1 to pop do writeln(nomf, frag[i]:3,' ',child[frag[i]].nom);

//Purge des paires
  //writeln(nomf,'paires restantes');
  n:=0;
  for i:=1 to nb_paire do begin
    ier1:=0;
    ier2:=0;
    for j:=1 to pop do begin
      if (frag[j] = paire[i].atome1) then ier1:=1;
      if (frag[j] = paire[i].atome2) then ier2:=1;
    end;
    if (ier1 = 0)and (ier2 = 0)then begin
      n:=n+1;
      paire[n]:=paire[i];
      writeln(nomf,paire[n].atome1,'-',paire[n].atome2);
    end;
  end;
  nb_paire:=n;
  writeln(nomf,'Nb de paires restantes: ',n);

//purge de child
  for i:=1 to pop do begin
    nb_content:=nb_content+1;
    content[nb_content]:=child[frag[i]];
    content [nb_content].nbfrg:=nb_fragments;
    child[frag[i]].nom:='';
  end;
  writeln(nomf,'nb. de child restant: ',nb_child:5);
  for i:=1 to nb_child do begin
    with(child[i]) do begin
      writeln(nomf,nom,i:4,x:10:5,y:10:5,z:10:5);
    end;
  end;
//---------------------------------------------------------------------------
  if (nb_paire > 0) then goto 1;
//---------------------------------------------------------------------------
  compacte_liste_child;
  if (nb_paire = 0) and (nb_child > 0) then begin
    for i:=1 to nb_child do begin
      nb_content:=nb_content+1;
      content[nb_content]:=child[i];
      nb_fragments:=nb_fragments+1;
      content[nb_content].nbfrg:=nb_fragments;
    end;
  end;

//Restauration de child
  nb_child:=nb_content;
  for i:=1 to nb_child do child[i]:=content[i];
  writeln(nomf,'Finalement:');
  for i:=1 to nb_child do begin
    with child[i] do begin
      writeln(nomf,nom,' ',i:5,x:10:5,y:10:5,z:10:5,nbfrg:3);
    end;
  end;
  closefile(nomf);

//*****************************************************************************
//Meilleure translation pour trouver la + proche position du centre de la maille
//*****************************************************************************
  for i:=1 to nb_fragments do begin
     xg:=0;yg:=0;zg:=0;dx:=0;dy:=0;dz:=0;
     n:=0;
     for j:=1 to nb_child do begin
       if (child[j].nbfrg = i)then begin
         with child[j] do begin
           n:=n+1;
           xg:=xg+x;
           yg:=yg+y;
           zg:=zg+z;
          // writeln(nomf,nom,x:10:5,y:10:5,z:10:5,nbfrg:5,beta[1]:10:5,beta[2]:10:5,
          // beta[3]:10:5, beta[4]:10:5, beta[5]:10:5, beta[6]:10:5);
         end;
       end;
     end;
     //writeln(nomf,'n:',n:5);
     xg:=xg/n; yg:=yg/n; zg:=zg/n;
     dmax:=10000;
     for ix:=-2 to 2 do begin
       for iy:=-2 to 2 do begin
         for iz:=-2 to 2 do begin
           x2:=xg+ix-0.5;
           y2:=yg+iy-0.5;
           z2:=zg+iz-0.5;
           trfo2(x2,y2,z2,r20);
           distance:=sqr(x2)+sqr(y2)+sqr(z2);
           if (distance < dmax) then begin
             dmax:=distance;
             dx:=ix;dy:=iy;dz:=iz;
           end;
         end;
       end;
     end;
     (*writeln(nomf,'fragment ',i:3);
     writeln(nomf,'g: ',xg:10:5,yg:10:5,zg:10:5);
     writeln(nomf,'Translation:',dx:6:2,dy:6:2,dz:6:2);  *)
     for j:=1 to nb_child do begin
       if (child[j].nbfrg = i)then begin
         with child[j] do begin
           x:=x+dx;
           y:=y+dy;
           z:=z+dz;
         end;
       end;
     end;
   end;
//******************************************************************************
 // closefile(nomf);

end;


end.
