unit fragment2;

interface

Uses
  SysUtils, WinTypes, WinProcs, Messages,StdCtrls, dialogs, math;

procedure calc_fragment_motif;

implementation
{R+}

uses
  oemath;

//Transforme les betaij de l'atome atm par l'oprateur no_op
procedure transf_beta(var no_op: integer; var atm: atomes);
//---------------------------------------------------------
var
  l,k                      : integer;
  r,r_trans,aux,bet        : matrice3;
begin
//Passage des uij aux bij
      with atm do begin
        bet[1,1]:=beta[1];
        bet[2,2]:=beta[2];
        bet[3,3]:=beta[3];
        bet[1,2]:=beta[4];
        bet[1,3]:=beta[5];
        bet[2,3]:=beta[6];
      end;
      for l:=1 to 3 do begin
        for k:=1 to 3 do begin
          //r[l,k]:=tp_sel[no_op,l,k];
          r[l,k]:=tp[no_op,l,k];
          r_trans[k,l]:=r[l,k];
        end;
      end;
      mat_mult(bet,r_trans,aux);
      mat_mult(r,aux,bet);
      with atm do begin
        beta[1]:=bet[1,1];
        beta[2]:=bet[2,2];
        beta[3]:=bet[3,3];
        beta[4]:=bet[1,2];
        beta[5]:=bet[1,3];
        beta[6]:=bet[2,3];
      end;
end;

//Les atomes N1 et n2 de motif sont-ils lis? si oui, no_op est > 0 et l'atome
//N2 est modifi par l'oprateur No no_op
procedure distanceij(var atm1,atm2,atm : atomes; var no_op: integer);
//-------------------------------------------------------------------
var
  el1,el2                                 : string;
  dmax,x1,y1,z1,x2,y2,z2,x3,y3,z3,
  x4,y4,z4,distance,dx,dy,dz              : double;
  i,j                                     : integer;
  ix,iy,iz,ipos                           : integer;
begin
    no_op:=0;
//Identification des lments
    //el1:=copy(atm1.nom,1,2);traite_nom_element(el1);el1:=trim(el1);
    //el2:=copy(atm2.nom,1,2);traite_nom_element(el2);el2:=trim(el2);
    el1:=uppercase(trim(atm1.element));
    el2:=uppercase(trim(atm2.element));
//Recherche de la distance max entre ces lments
    dmax:=0;
    for i:= 1 to nb_typ_liai do begin
      if ((tableau_liai[i].atome1 = el1) and (tableau_liai[i].atome2 = el2)) or
      ((tableau_liai[i].atome2 = el1) and (tableau_liai[i].atome1 = el2)) then
      begin
        dmax:=sqr(tableau_liai[i].distance);
        break;
      end;
    end;
    if (dmax = 0)then exit;
//On cerche si les atomes sont lis en faisant des translations et oprations de symtrie
    x1:=atm1.x;
    y1:=atm1.y;
    z1:=atm1.z;
    x2:=atm2.x;
    y2:=atm2.y;
    z2:=atm2.z;
    for ix:=-1 to 1 do begin
      dx:=ix;
      for iy:=-1 to 1 do begin
        dy:=iy;
        for iz:=-1 to 1 do begin
          dz:=iz;
          for ipos:=1 to npos do begin
            x3:=x2*tp[ipos,1,1]+y2*tp[ipos,1,2]+z2*tp[ipos,1,3]+tp[ipos,1,4]+dx;
            y3:=x2*tp[ipos,2,1]+y2*tp[ipos,2,2]+z2*tp[ipos,2,3]+tp[ipos,2,4]+dy;
            z3:=x2*tp[ipos,3,1]+y2*tp[ipos,3,2]+z2*tp[ipos,3,3]+tp[ipos,3,4]+dz;
            x4:=x3-x1;
            y4:=y3-y1;
            z4:=z3-z1;
            trfo2(x4,y4,z4,r20);
            distance:=sqr(x4)+sqr(y4)+sqr(z4);
            if (distance <= dmax)then begin
              no_op:=ipos;
              atm:=atm2;
              atm.x:=x3;
              atm.y:=y3;
              atm.z:=z3;
//Calcul des betai,j
              if (atm.iso = 0)then transf_beta(no_op,atm);
              exit;
            end;
          end;
        end;
      end;
    end;
end;

procedure calc_fragment_motif;
//-------------------------------
var
  fragm                                         : array[1..100,1..100] of ^atomes;
  pop                                           : array[1..100] of integer;
  //nb_fragm                                      : integer;
  i,j,no_op,i_cour,nb_total                     : integer;
  atm1,atm2,atm3                                : atomes;
  //nomf                                        : textfile;
begin
  nb_fragm:=0;
  nb_total:=0;

  (*assignfile(nomf,'frg.esp');
  rewrite(nomf); *)

  repeat

    nb_fragm:=nb_fragm+1;
    new(fragm[nb_fragm,1]);
    pop[nb_fragm]:=1;
    nb_total:=nb_total+1;
    for i:=1 to nb_motif do begin
      if (motif[i].nom <> '')then begin
        fragm[nb_fragm,1]^:=motif[i];
        motif[i].nom:='';
        motif[i].element:='';
        motif[i].labell:='';
        break;
      end;
    end;
    i_cour:=1;

    //writeln(nomf,'nb_fragm:',nb_fragm:4);
    //with fragm[nb_fragm,1]^ do writeln(nomf,nom:4,x:8:4,y:8:4,z:8:4);

    repeat
      atm1:=fragm[nb_fragm,i_cour]^;

      //writeln(nomf,'i_cour:',i_cour:4);
      //with atm1 do writeln(nomf,nom:4,x:8:4,y:8:4,z:8:4);

      for j:=1 to nb_motif do begin
        if (motif[j].nom = '')then continue;
        atm2:=motif[j];
        distanceij(atm1,atm2,atm3,no_op);
        if (no_op = 0)then continue;
        pop[nb_fragm]:=pop[nb_fragm]+1;
        nb_total:=nb_total+1;
        new(fragm[nb_fragm,pop[nb_fragm]]);
        fragm[nb_fragm,pop[nb_fragm]]^:=atm3;

        //with motif[j] do writeln(nomf,nom:4,x:8:4,y:8:4,z:8:4,beta[1]:8:4);
        //with atm3 do writeln(nomf,nom:4,x:8:4,y:8:4,z:8:4,beta[1]:8:4);

        motif[j].nom:='';
        motif[j].element:='';
        motif[j].labell:='';
      end;
      i_cour:=i_cour+1;
    until i_cour>pop[nb_fragm];

  until nb_total = nb_motif;

  nb_motif:=0;
  for i:=1 to nb_fragm do begin
    for j:=1 to pop[i] do begin
      nb_motif:=nb_motif+1;
      motif[nb_motif]:=fragm[i,j]^;
      motif[nb_motif].nbfrg:=i;
      dispose(fragm[i,j]);
    end;
  end;
  //closefile(nomf);
end;

end.
