unit licif2;

interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TForm1 = class(TForm)
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

procedure lit_fichier_cif(var ier:integer);

implementation


uses
  oemath, quel_bloc;
type
  tabs                         =  array[1..12] of string[15];
var
  ordre_lecture                  : array[1..10] of integer;
  alire_site                     : array[1..7] of string[40] =
 ('_atom_site_label         ',
  '_atom_site_fract_x       ',
  '_atom_site_fract_y       ',
  '_atom_site_fract_z       ',
  '_atom_site_U_iso_or_equiv',
  '_atom_site_thermal_displace_type',
  '_atom_site_type_symbol');

  alire_uij                     : array[1..7] of string[25] =
    ('_atom_site_aniso_label',
    '_atom_site_aniso_U_11',
    '_atom_site_aniso_U_22',
    '_atom_site_aniso_U_33',
    '_atom_site_aniso_U_12',
    '_atom_site_aniso_U_13',
   ' _atom_site_aniso_U_23' );

//Extrait jusqu'a 10 rels d'une chaine s. no:nb de rels trouvs(==>tableau )
procedure dec(s:string; var tableau:tab_reel; var no,ier:integer);
//----------------------------------------------------------------
var
  s1                            : string;
  i,j,l                         : integer;
 no_erreur                      : array[1..11] of integer;

begin
  s:=trim(s);
  l:=length(s);
  no:=0;
  for i:=1 to l do begin
    if (s[i] = ',') then s[i]:=' ';
  end;
  for i:=1 to 11 do tableau[i]:=0;

  while (l > 0) do begin
    j:=pos(' ',s);
    if (j = 0)then j:=l;
    no:=no+1;
    s1:=copy(s,1,j);
    s1:=trim(s1);
    no_erreur[no]:=0;
    val(s1,tableau[no],ier);
    if(ier <> 0)then  no_erreur[no]:=1;
    delete(s,1,j);
    s:=trim(s);
    l:=length(s);
  end;
end;

procedure decchaine(s: string; var line: vecteur3; var t: double);{
----------------------------------------------------------------
Dcode une sous chaine d'une chaine-position}
var
  i,j,ier,l,k          : integer;

const
  code_pos      : array[1..14] of string =
  ('X+Y','X-Y','Y-X','-Y+X','-X+Y','-X','-Y', '-Z','+X','+Y','+Z','X','Y','Z');
  ligne         : array[1..42] of double   =
  (1,1,0,1,-1,0,-1,1,0,1,-1,0,-1,1,0,-1,0,0,0,-1,0,0,0,-1,1,0,0,0,1,0,0,0,1
                                                   ,1,0,0,0,1,0,0,0,1);
begin
{suppression des formats fortran}
   i:=pos(' .',s);
   if(i > 0)then s[i]:='0';
   i:=pos('. ',s);
   if(i > 0)then s[i+1]:='0';
{recherche vecteur de position }
   for i:=1 to 14 do begin
     j:=pos(code_pos[i],s);
     if (j > 0) then begin
       k:=(i-1)*3 ;
       line[1]:=ligne[k+1];
       line[2]:=ligne[k+2];
       line[3]:=ligne[k+3];
       l:=length(code_pos[i]);
       delete(s,j,l);
       break;
     end;
   end;
//Translations
   s:=trim(s);
   val(s,t,ier);
end;

procedure decsym(s: string; var r:matrice3; var t:vecteur3); {
-------------------------------------------------------------}
  {Dcodage d'une position, Sparation des 3 sous-chaines, par recherche des
  virgules}
var
  s1,s2,s3                   : string;
  i                          : integer;
  v                          : vecteur3;
begin

  i:=pos(',',s);
  s1:=copy(s,1,i);
  s1[i]:=' ';
  delete(s,1,i);
  s:=trim(s);

  i:=pos(',',s);
  s2:=copy(s,1,i);
  s2[i]:=' ';
  delete(s,1,i);
  s:=trim(s);

  s3:=s;

  s1:=trim(s1);
  s2:=trim(s2);
  s3:=trim(s);

//Dcodage de chaque sous-chaine
  for i:=1 to 3 do begin
    v[i]:=0;
    t[i]:=0;
  end;
  decchaine(s1,v,t[1]);
  for i:=1 to 3 do r[1,i]:=v[i];
  decchaine(s2,v,t[2]);
  for i:=1 to 3 do r[2,i]:=v[i];
  decchaine(s3,v,t[3]);
  for i:=1 to 3 do r[3,i]:=v[i];
end;

procedure dec_val(s:string;var r:vecteur3;var t:real);
//---------------------------------------------------
//dcode une chaine contenant une position ==> un vecteur + la translation
var
  i,j,k,n,ier  : integer;
  s1           : string;
const
  cxyz : array[1..14] of string[4]=
  ('X-Y','Y-X','-X+Y','-Y+X','X+Y',
   '+X','+Y','+Z',
  '-X','-Y','-Z',
  'X','Y','Z');
  vxyz : array [1..42] of real=
   (1,-1, 0,-1, 1, 0, -1, 1, 0, 1,-1, 0,1,1,0,
    1, 0, 0, 0, 1, 0, 0, 0, 1,
   -1, 0, 0 ,0,-1, 0, 0, 0,-1,
    1, 0, 0, 0, 1, 0, 0, 0, 1);
  ct   : array[1..23] of string[4]=
  ('    ','+1/2','+1/3','+2/3','+1/4','+3/4','+1/6','+5/6',
          '-1/2',  '-1/3','-2/3','-1/4','-3/4','-1/6','-5/6',
          '1/2', '1/3', '2/3', '1/4', '3/4', '1/6', '5/6','1');
  vt   : array[1..23] of real =
  ( 0.,0.5, 0.3333333, 0.6666667, 0.25,  0.75, 0.166667, 0.83333,
      -0.5, -0.3333333,-0.6666667,-0.25,-0.75,-0.166667,-0.83333,
       0.5, 0.3333333, 0.6666667, 0.25,  0.75, 0.166667, 0.83333,1);
begin
  t:=0;
  s:=trim(s);

//1-Recherche de la position ==> vecteur r
  ier:=1;
  for i:=1 to 14 do begin
    s1:=trim(cxyz[i]);
    j:=pos(s1,s);
    if (j > 0)then begin
      n:=(i-1)*3;
      r[1]:=vxyz[n+1];
      r[2]:=vxyz[n+2];
      r[3]:=vxyz[n+3];
      k:=length(s1);
      delete(s,j,k);
      ier:=0;
    end;
  end;
  if (ier = 1)then begin
    erreur('cannot decode position'+s);
    halt;
  end;

//2-Recherche de la translation ==> t
  s:=trim(s);
  ier:=1;
  if (s = '')then begin
    t:=0;
    exit;
  end;
  if (s[length(s)] = '+')or (s[length(s)] = '-') then delete(s,length(s),1);
  j:=pos('/',s);
  if (j > 0)then begin
    s1:=trim(copy(s,1,j-1));
    delete(s,1,j);
    s:=trim(s);
    t:=strtoint(s1)/strtoint(s);
    ier:=0;
  end else begin
    val(s,t,ier);
    ier:=0;
  end;
  if (ier > 0)then begin
    erreur('Cannot decode translation'+s);
    halt;
  end;
end;

{Guerrit les .0 0. et -.}
procedure verif(var s:string);{
------------------------------}
begin
  while (pos(' .',s) > 0)do begin
    insert('0',s,pos(' .',s)+1);
  end;
  while (pos(' -.',s) > 0)do begin
    insert('0',s,pos(' -.',s)+2);
  end;
end;

procedure decode_cif_atomes(var s,label_atome:string; var x,y,z,t :real);
//-----------------------------------------------------------------------
var
  ier,i,no                      : integer;
  tableau                       : tab_reel;
  s1                            : string;
begin
  s1:=s;
  verif(s1);
  i:=pos(' ',s1);
  label_atome:=copy(s1,1,i-1);label_atome:=trim(label_atome);
  delete(s1,1,i-1);
  while (pos('(',s1) > 0) do delete(s1,pos('(',s1),pos(')',s1)-pos('(',s1)+1);
  s1:=trim(s1);
  dec(s1,tableau,no,ier);
  x:=tableau[1];
  y:=tableau[2];
  z:=tableau[3];
  t:=tableau[4];
end;

procedure lit_titre;
//------------------
var
  nomf              : textfile;
  s,s1,s2           : string;
  i                 : integer;
  tit               : array[1..7] of string[40];
begin
    AssignFile(nomf,nom_fichier_shelx);
    reset(nomf);
    //if (nb_ligne_choisi > 0)then for i:=1 to nb_ligne_choisi do readln(nomf);

    titre:='';
    for i:=1 to 5 do tit[i]:='';
    while not(eof(nomf)) do begin
       readln(nomf,s1);
       s1:=trim(s1);
       if (s1 = '')then continue;
       if (pos('_chemical_formula_moiety',s1) > 0)   then begin
           if (length(s1) > 24)then s:=trim(copy(s1,25,length(s1)-25+1))
           else readln(nomf,s);
           s:=trim(s);
           if (s = '')then begin
             repeat
               readln(nomf,s);
               s:=trim(s);
             until (s <> '');
           end;
           if (s = ';' )then readln(nomf,s2);
           tit[1]:=trim(s2);
       end;
       if (pos('_chemical_formula_structural',s1) > 0)   then begin
           if (length(s1) > 28)then s:=trim(copy(s1,29,length(s1)-29+1))
           else readln(nomf,s);
           s:=trim(s);
           if (s = '')then begin
             repeat
               readln(nomf,s);
               s:=trim(s);
             until (s <> '');
           end;
           if (trim(s) = ';' )then readln(nomf,s);
           tit[2]:=trim(s);
       end;
       if (pos('_chemical_formula_analytical',s1) > 0)   then begin
           if (length(s1) > 28)then s:=trim(copy(s1,29,length(s1)-29+1))
           else readln(nomf,s);
           s:=trim(s);
           if (s = '')then begin
             repeat
               readln(nomf,s);
               s:=trim(s);
             until (s <> '');
           end;
           if (trim(s) = ';' )then readln(nomf,s);
           tit[3]:=trim(s);
       end;
       if (pos('_chemical_formula_sum',s1) > 0)   then begin
           if (length(s1) > 21)then s:=trim(copy(s1,22,length(s1)-22+1))
           else readln(nomf,s);
           s:=trim(s);
           if (s = '')then begin
             repeat
               readln(nomf,s);
               s:=trim(s);
             until (s <> '');
           end;
           if (trim(s) = ';' )then readln(nomf,s);
           tit[4]:=trim(s);
       end;
       if (pos('_chemical_formula_iupac',s1) > 0)   then begin
           if (length(s1) > 23)then s:=trim(copy(s1,24,length(s1)-24+1))
           else readln(nomf,s);
           s:=trim(s);
           if (s = '')then begin
             repeat
               readln(nomf,s);
               s:=trim(s);
             until (s <> '');
           end;
           if (trim(s) = ';' )then readln(nomf,s);
           tit[5]:=trim(s);
       end;
     end;
     for i:=1 to 5 do begin
       if (tit[i] = '') or (tit[i] = '?')then continue;
         titre:=tit[i];
         formule:=titre;
         break;
     end;
     while (pos('''',titre) > 0) do titre[pos('''',titre)]:=' ';
     while (pos(';',titre) > 0)  do titre[pos(';',titre)]:=' ';
     while (pos('"',titre) > 0)  do titre[pos('"',titre)]:=' ';

     closefile(nomf);
     while (pos(' ',titre) > 0) do delete(titre,pos(' ',titre),1);
end;

procedure lit_maille(var ier:integer);
//------------------------------------
var
 nomf                           : textfile;
 s,s1                           : string;
 i,j                            : integer;
 label 1;
begin
//Lecture de la maille
    ier:=0;

    AssignFile(nomf,nom_fichier_shelx);
    reset(nomf);
    //if (nb_ligne_choisi > 0)then for i:=1 to nb_ligne_choisi do readln(nomf);

    while not(eof(nomf)) do begin
      readln(nomf,s);
      s:=trim(s);
      s1:='_cell_length_a';
      i:=length(s1);
      if (pos(s1,s)> 0) then begin
        s:=copy(s,i+1,length(s)-i);
        s:=trim(s);
        j:=pos('(',s);          //sigma!!!
        if (j >  0) then begin
          delete(s,j,length(s)-j+1);
          s:=trim(s);
        end;
        val(s,cel[1],ier);
      end;

      s1:='_cell_length_b';
      i:=length(s1);
      if (pos(s1,s)> 0) then begin
        s:=copy(s,i+1,length(s)-i);
        s:=trim(s);
        j:=pos('(',s);          //sigma!!!
        if (j >  0) then begin
          delete(s,j,length(s)-j+1);
          s:=trim(s);
        end;
        val(s,cel[2],ier);
      end;

      s1:='_cell_length_c';
      i:=length(s1);
      if (pos(s1,s)> 0) then begin
        s:=copy(s,i+1,length(s)-i);
        s:=trim(s);
        j:=pos('(',s);          //sigma!!!
        if (j >  0) then begin
          delete(s,j,length(s)-j+1);
          s:=trim(s);
        end;
        val(s,cel[3],ier);
      end;

      s1:='_cell_angle_alpha';
      i:=length(s1);
      if (pos(s1,s)> 0) then begin
        s:=copy(s,i+1,length(s)-i);
        s:=trim(s);
        j:=pos('(',s);          //sigma!!!
        if (j >  0) then begin
          delete(s,j,length(s)-j+1);
          s:=trim(s);
        end;
        if (s = '?') then cel[4]:=90 else val(s,cel[4],ier);
      end;

      s1:='_cell_angle_beta';
      i:=length(s1);
      if (pos(s1,s)> 0) then begin
        s:=copy(s,i+1,length(s)-i);
        s:=trim(s);
        j:=pos('(',s);          //si le sigma est prsent !!!
        if (j >  0) then begin
          delete(s,j,length(s)-j+1);
          s:=trim(s);
        end;
        if (s = '?') then cel[5]:=90 else val(s,cel[5],ier);
      end;

      s1:='_cell_angle_gamma';
      i:=length(s1);
      if (pos(s1,s)> 0) then begin
        s:=copy(s,i+1,length(s)-i);
        s:=trim(s);
        j:=pos('(',s);          //si le sigma est prsent !!!
        if (j >  0) then begin
          delete(s,j,length(s)-j+1);
          s:=trim(s);
        end;
        if (s = '?') then cel[6]:=90 else val(s,cel[6],ier);
        break;
      end;
    end;
    closefile(nomf);
end;

Procedure lit_symetries(var ier:integer);
//--------------------------------------
var
 nomf                           : textfile;
 s,s1                           : string;
 i,j                            : integer;
 r                              : vecteur3;
 t                              : real;
 numerotation                   : boolean;
 esp                            : textfile;
 label 1;
begin
//Recherche des symtries;
    ier:=0;

    AssignFile(nomf,nom_fichier_shelx);
    reset(nomf);
    //if (nb_ligne_choisi > 0) then for i:=1 to nb_ligne_choisi do readln(nomf);

    npos:=0;
    numerotation:=false;

    // assignfile(esp,'espion');
    //rewrite(esp);

    while not eof(nomf) do begin
      readln(nomf,s);
      s:=trim(s);
      if (pos('_symmetry_equiv_pos_as_xyz',s) = 0)then continue
      else begin
        npos:=1;
        readln(nomf,s);
        s:=uppercase(s);
        s:=trim(s);

//Correction du 19/03/03 pour tenir compte de la prsence du caractre de tabulation
        s1:=chr(9);
        j:= pos(s1,s);
        if (j > 0)then begin
          delete (s,j,1);
          insert(' ',s,j);
      end;

        s1:=copy(s,1,2);
        if (s1 = '1 ')then begin
           numerotation:=true;
        end;
//Correction du 23 mai 2001:les positions sont numerotes!
        if (numerotation = true)then s:=copy(s,pos(' ',s),length(s)-pos(' ',s)+1);
        s:=trim(s);
        while (pos('''',s) > 0)do delete(s,pos('''',s),1);
        if (pos(' ',s) > 0)then while (pos(' ',s) > 0)do delete(s,pos(' ',s),1);
        s_pos[npos]:=s;
        selected[npos]:=1;
        repeat
          readln(nomf,s);
          s:=trim(s); s:=uppercase(s);

//Correction du 19/03/03 pour tenir compte de la prsence du caractre de tabulation
          if (j > 0)then begin
            delete (s,j,1);
            insert(' ',s,j);
          end;

//Correction du 4 mai 2003
          if (pos('_',s) > 0) or (trim(s) = '') or (pos('#',s) >0) then break;
          npos:=npos+1;

//Correction du 23 mai 2001:les positions sont numerotes!
          if (numerotation = true)then s:=copy(s,pos(' ',s),length(s)-pos(' ',s)+1);
          s:=trim(s);
          while (pos('''',s) > 0)do delete(s,pos('''',s),1);
          if (pos(' ',s) > 0)then while (pos(' ',s) > 0)do delete(s,pos(' ',s),1);
          s_pos[npos]:=s;
          selected[npos]:=0;
        until (pos('_',s) > 0) ;

        for i:=1 to npos do begin
          s:=s_pos[i];
          s:=ansiuppercase(s);
          //x
          j:=pos(',',s);
          s1:=copy(s,1,j-1);
          delete(s,1,j);
          dec_val(s1,r,t);
          for j:=1 to 3 do tp[i,1,j]:=r[j];
          tp[i,1,4]:=t;
          //Y
          j:=pos(',',s);
          s1:=copy(s,1,j-1);
          delete(s,1,j);
          dec_val(s1,r,t);
          for j:=1 to 3 do tp[i,2,j]:=r[j];
          tp[i,2,4]:=t;
          //Z
          dec_val(s,r,t);
          for j:=1 to 3 do tp[i,3,j]:=r[j];
          tp[i,3,4]:=t;
         (* writeln(esp,tp[i,1,1]:5:0,tp[i,1,2]:5:0,tp[i,1,3]:5:0,tp[i,1,4]:8:5);
          writeln(esp,tp[i,2,1]:5:0,tp[i,2,2]:5:0,tp[i,2,3]:5:0,tp[i,2,4]:8:5);
          writeln(esp,tp[i,3,1]:5:0,tp[i,3,2]:5:0,tp[i,3,3]:5:0,tp[i,3,4]:8:5);
          writeln(esp);
          *)
        end;

//On slectionne la position triviale
        npos_sel:=1;
        for i:=1 to 3 do
        for j:=1 to 4 do begin
          tp_sel[1,i,j]:=0;
          if (i = j)then tp_sel[1,i,j]:=1;
        end;
      end;
      break;
    end;

    //closefile(esp);
    closefile(nomf);

//Recherche du groupe d'espace
    AssignFile(nomf,nom_fichier_shelx);
    reset(nomf);
   // if (nb_ligne_choisi > 0) then for i:=1 to nb_ligne_choisi do readln(nomf);

    groupe_espace:='';
    while not eof(nomf) do begin
      readln(nomf,s);
      s:=trim(s);

//Hermann-Mauguin
      if (pos('_symmetry_space_group_name_H-M',s) > 0)then begin
        i:=pos(' ',s);
        s:=copy(s,i,length(s)-i+1);
        while (pos('''',s) > 0)do delete(s,pos('''',s),1);
        while (pos(' ',s) > 0)do delete(s,pos(' ',s),1);
        groupe_espace:=trim(s);
        break;
      end;

//Hall
      if (pos('_symmetry_space_group_name_Hall',s) > 0)then begin
        i:=pos(' ',s);
        s:=copy(s,i,length(s)-i+1);
        while (pos('''',s) > 0)do delete(s,pos('''',s),1);
        s:=uppercase(s);
        groupe_espace:=trim(s);
        break;
      end;
    end;
    closefile(nomf);

    if (npos = 0) and (groupe_espace = '')then begin
      erreur('Gretep cannot find symmetry operators or Space group');
      ier:=1;
      exit;
    end;

end;

procedure decompose(s:string; var tab:tabs);
//-----------------------------------------
var
  i,n,l        : integer;
begin
  verif(s);
  for i:=1 to 12 do tab[i]:='';
  s:=trim(s);
  l:=length(s);
  n:=0;
  while (l > 0) do begin
    i:=pos(' ',s);
    if (i > 0)then begin
      n:=n+1;
      tab[n]:=copy(s,1,i-1);
      delete(s,1,i);
      s:=trim(s);
    end else begin
      n:=n+1;
      tab[n]:=trim(s);
      break;
    end;
    l:=length(s);
  end;
  for i:=1 to n do begin
    s:=trim(tab[i]);
    while (pos('(',s) > 0) do delete(s,pos('(',s),pos(')',s)-pos('(',s)+1);
    tab[i]:=s;
  end;
end;

procedure compte_string(var s:string; var n:integer);
//--------------------------------------------------
var
  i,l        : integer;
  s1         : string;
begin
  s1:=s;
  l:=length(s1);
  n:=1;
  while (l > 0) do begin
    i:=pos(' ',s1);
    if (i > 0)then begin
      n:=n+1;
      delete(s1,1,i);
      s1:=trim(s1);
    end else break;
    l:=length(s1);
  end;
end;

procedure fraction(s: string; var x:real);
//----------------------------------------
var
  s1,s2  : string;
  x1,x2  : real;
  ier,i  : integer;
begin
  x:=0;
  if (pos('/',s) > 0)then begin
    i:=pos('/',s);
    s1:=trim(copy(s,1,i-1));
    s2:=trim(copy(s,i+1,length(s)-i));
    val(s1,x1,ier);
    val(s2,x2,ier);
    x:=x1/x2;
  end;
end;

procedure purge_fichier_cif;
//--------------------------
var
  nom1,nom2         : textfile;
  s                 : string;
  n1,n2,i           : integer;
begin
  AssignFile(nom1,nom_fichier_shelx);
  reset(nom1);
  s:=repertoire_origine+'\'+'dummy.cif';
  if fileExists(s) then deleteFile(s);
  AssignFile(nom2,s);
  rewrite(nom2);
  n1:=bloc[numero_bloc].debut;
  n2:=bloc[numero_bloc].fin;
  if (n1 > 1)then for i:=1 to n1-1 do readln(nom1);
  for i:=n1 to n2 do begin
    readln(nom1,s);
    s:=trim(s);
    if (s = '')then continue;
    writeln(nom2,s);
  end;
  writeln(nom2);
  closeFile(nom1);
  closefile(nom2);
end;

procedure decode_element_label(var s,s1: string);
//-----------------------------------------------
var
 c                              : char;
 c2                             : string[2];
 i,ier                          : integer;
begin
  s:=trim(s);
  c2:=copy(s,1,2);
  c:=c2[2];
  if (ord(c) > 47) and (ord(c) < 58)then begin  //(s = element, s1=label)
    s1:=copy(s,2,length(s)-1);
    delete(s,2,length(s)-1);
  end else begin
    s1:=copy(s,3,length(s)-2);
    delete(s,3,length(s)-2);
  end;
  ier:=1;
  for i:=1 to 95 do begin
    if (elem_crom[i] = uppercase(s))then begin
      ier:=0;
      break;
    end;
  end;
  if (ier > 0)then begin
    if (length(s) = 2)then delete(s,2,1) else erreur('cannot decode Label'+s);
  end;

end;

procedure lit_fichier_cif(var ier:integer);
//--------------------------------------
var
 nomf                           : textfile;
 s,s1,atome_label,ligne         : string;
 i,j,k,no,n,nb_aniso            : integer;
 x,y,z,t                        : real;
 tableau                        : tab_reel;

 site,uij                       : array[1..15]of string[40];
 nb_site,nb_uij                 : integer;
 chaines                        : tabs;

 type_symbol                    : string[2];
 nom_old                        : string;

 bet                            : matrice3;
 u_iso                          : real;
 c                              : char;

 tt,v                           : array[1..6] of double;
 mat,mat_inv,r12t,aux           : matrice3;
 ueq,depi2                      : double;
 label 1;

begin

   purge_fichier_cif;
   nom_old:=nom_fichier_shelx;
   chdir(repertoire_origine);
   nom_fichier_shelx:='dummy.cif';
   ier:=0;

//Fichier d'criture
   ier:=0;
   lit_titre;
   lit_maille(ier);
   lit_symetries(ier);
   if (ier > 0)then exit;

//Lecture des atomes
    AssignFile(nomf,nom_fichier_shelx);
    reset(nomf);
    i:=0;
    nb_motif:=0;

//Recherche de la premire carte _atom_site
    while not eof(nomf) do begin
      readln(nomf,s);
      s:=trim(s);
      if (pos('loop_',s) = 0) then continue;
      readln(nomf,s);
      if (pos('_atom_site_',s) = 0) then continue;
      site[1]:=trim(s);

//Dtection de l'ordre de lecture
      nb_site:=1;
      repeat
        readln(nomf,s);
        s:=trim(s);
        if (pos('_atom_site_',s) > 0) then begin
          nb_site:=nb_site+1;
          site[nb_site]:=trim(s);
        end;
      until (pos('_atom_site_',s) = 0);     //Premier atome
      ligne:=trim(s);

//Ligne incomplete
      compte_string(ligne,n);
       while (n < nb_site) do begin
         readln(nomf,s);
         ligne:=ligne+' '+trim(s);
         compte_string(ligne,n);
       end;

       for i:=1 to 7 do begin
        s:=trim(alire_site[i]);
        for j:=1 to nb_site do begin
          s1:=site[j];
          if (s = s1)then begin
            ordre_lecture[i]:=j;
            break;
          end;
        end;
      end;

      s:='';
      for i:=1 to 7 do begin
        str(ordre_lecture[i]:4,s1);
        s:=s+s1;
      end;

      ier:=0;
      s:=ligne;
      i:=0;

//lecture et decodage
      repeat
         i:=i+1;
         decompose(s,chaines);
             s:=chaines[ordre_lecture[1]];
             motif[i].nom:=s;
             decode_element_label(s,s1);
             motif[i].element:=s;
             motif[i].labell:=s1;

//X
         s1:=chaines[ordre_lecture[2]];
         if (pos('/',s1) = 0)then val(s1,x,j) else fraction(s1,x);
         motif[i].x:=x;
//Y
         s1:=chaines[ordre_lecture[3]];
         if (pos('/',s1) = 0)then val(s1,y,j) else fraction(s1,y);
         motif[i].y:=y;
//Z
         s1:=chaines[ordre_lecture[4]];
         if (pos('/',s1) = 0)then val(s1,z,j) else fraction(s1,z);
         motif[i].z:=z;

//B equivalent
         if (ordre_lecture[5] = 0)then t:=0.1
         else begin
           s1:=chaines[ordre_lecture[5]];
           val(s1,t,j);
         end;
         motif[i].beta[1]:=t;

         for k:=2 to 6 do motif[i].beta[k]:=0;
         motif[i].iso:=1;
         readln(nomf,s);
         s:=trim(s);
         if (s  = '') or (s = 'loop_') or (pos('#END',uppercase(s)) > 0)
         or (pos('_',s) = 1) then goto 1 ;

//Ligne incomplete
         compte_string(s,n);
         while (n < nb_site) do begin
           readln(nomf,s1);
           s:=s+' '+trim(s1);
           compte_string(s,n);
         end;
         s:=trim(s);
         if (s = '') or (pos('_',s) > 0) or eof(nomf) or (s[1] = '#') then goto 1
      until (s = '') or (pos('_',s) > 0);
    end;
1:  nb_motif:=i;
    closefile(nomf);

    if (nb_motif = 0)then begin
      ier:=1;
      erreur('No atom site found');
      exit;
    end;

//-----------------------------------------------------------------------------
//Recherche des coefficients anisotropes
//-----------------------------------------------------------------------------
    AssignFile(nomf,nom_fichier_shelx);
    reset(nomf);
    nb_aniso:=0;
    while not eof(nomf) do begin
      readln(nomf,s);
      s:=trim(s);
      if (pos('loop',s) = 0) then continue;
      readln(nomf,s);
      if (pos('_atom_site_aniso_label',s) = 0) then continue;
      nb_aniso:=1;
      uij[1]:=trim(s);
      repeat
        readln(nomf,s);
//Stockage des cartes site_aniso lues
        if (pos('atom_site_aniso',s) > 0)then begin
          nb_aniso:=nb_aniso+1;
          uij[nb_aniso]:=trim(s);
        end;
      until (pos('atom_site_aniso',s) = 0);
      break;
    end;
    s:=trim(s);
    compte_string(s,n);
    while (n < nb_aniso) do begin
           readln(nomf,s1);
           s:=s+' '+trim(s1);
           compte_string(s,n);
    end;
    ligne:=s;

//Ordre de lecture
    for i:=1 to 7 do begin
      s:=trim(alire_uij[i]);
      ordre_lecture[i]:=0;
      for j:=1 to nb_aniso do begin
        s1:=trim(uij[j]);
        if (s = s1)then begin
          ordre_lecture[i]:=j;
          break;
        end;
      end;
    end;
    s:=ligne ;
    for i:=1 to 3 do begin
      for j:=1 to 3 do begin
        r12t[j,i]:=r12[i,j];
      end;
    end;
    while not eof(nomf) do begin
      if (pos('_',s) > 0)then break;
      decompose(s,chaines);
      s1:=chaines[ordre_lecture[1]];
      atome_label:=trim(s1);
      atome_label:=uppercase(atome_label);

//Recherche de l'atome dans le record motif
      for i:=1 to nb_motif do begin
        s1:=trim(uppercase(motif[i].nom));
        if (s1 = atome_label)then begin
          u_iso:=motif[i].beta[1];
          for k:=1 to 6 do begin
             val(chaines[ordre_lecture[k+1]],x,j);
             motif[i].beta[k]:=x;
             motif[i].iso:=0;
          end;

          with motif[i] do begin
            if (iso = 1)then continue;
            bet[1,1]:=beta[1];
            bet[2,2]:=beta[2];
            bet[3,3]:=beta[3];
            bet[1,2]:=beta[4];
            bet[1,3]:=beta[5];
            bet[2,3]:=beta[6];
            bet[2,1]:=beta[4];
            bet[3,1]:=beta[5];
            bet[3,2]:=beta[6];
            teste_matrice_beta(bet,ier);
            if (ier = 1)then begin
              for j:=1 to 6 do beta[j]:=0;
              if (u_iso = 0)then u_iso:=(bet[1,1]+bet[2,2]+bet[3,3])/3;
              beta[1]:=u_iso;
              beep;
              str(u_iso:6:4,s);
              erreur ('Atom '+nom+' has a non definite positive matrix Uij. Ueq was reset to '+s);
              iso:=1;
            end;
          end;
        end;
      end;
      if eof(nomf)then break
      else readln(nomf,s);
      if (pos('_',s) > 0) or (s = '') then break;
      s:=trim(s);
      compte_string(s,n);
      while (n < nb_aniso) do begin
        readln(nomf,s1);
        if (pos('_',s) > 0)then break;
        s:=s+' '+trim(s1);
        compte_string(s,n);
      end;
    end;
    closefile(nomf);
    nom_fichier_shelx:=nom_old;

  (*  assignFile(nomf,'espion');
    rewrite(nomf);
    for i:=1 to nb_motif do begin
      with motif[i] do begin
        writeln(nomf,nom:6,element:2,labell:4,x:10:6,y:10:6,z:10:6);
        for j:=1 to 6 do write(nomf,beta[j]:10:6);
        writeln(nomf);
      end;
    end;
    closefile(nomf);  *)

end;

end.



