unit predessin;


interface
 Uses
  SysUtils, WinTypes, WinProcs, Messages,
  Controls, StdCtrls,  math;

procedure diagonalise;

implementation

uses
  oemath, diag;

procedure diagonalise;{
-----------------------
Diagonalisation des matrices beta}
var
  mat,mat_inv,mat_vec_prop,r12t,bet,aux           : matrice3;
  val_prop                                        : vecteur3;
  i,j,iat                                         : integer;
  pi2,g2,b0                                       : double;
  s2                                              : string[2];
  nomf                                            : TextFile;
const
  g_prob : array[1..10] of double
         =(0.7644,1.0026,1.1932,1.3672,1.5382,1.7164,1.9144,2.1544,2.5,5.95);
begin
 //AssignFile(nomf,'diag.esp');
 //rewrite(nomf);
 setmat;
 pi2:=2*pi*pi;
 g2:=sqr(g_prob[probabilite]);
 for i:=1 to 3 do begin
   for j:=1 to 3 do begin
     r12t[j,i]:=r12[i,j];
   end;
 end;
 (*writeln(nomf,'r12');
  for i:=1 to 3 do begin
    for j:=1 to 3 do write(nomf,r12[i,j]:10:6);
    writeln(nomf);
 end;*)
 for iat:=1 to nb_child do begin
   child[iat].couleur:=0;
   for i:=1 to 13 do begin
     s2:=copy(child[iat].nom,1,2);
     s2:=trim(s2);
     if (s2 = elements[i])then begin
       child[iat].couleur:=i;
       break;
     end;
   end;

   for i:=1 to 3 do
     for j:=1 to 3 do bet[i,j]:=0;
   if(child[iat].beta[2] = 0)then begin
     b0:=child[i].beta[1];
     bet[1,1]:=b0*ae*ae*pi2/2;
     bet[2,2]:=b0*be*be*pi2/2;
     bet[3,3]:=b0*ce*ce*pi2/2;
     bet[1,2]:=b0*ae*be*cce*pi2/2;
     bet[1,3]:=b0*ae*ce*cbe*pi2/2;
     bet[2,3]:=b0*be*ce*cae*pi2/2;
     bet[2,1]:=bet[1,2];
     bet[3,1]:=bet[1,3];
     bet[3,2]:=bet[2,3];
   end else begin;
     with child[iat] do begin
       case mode_coef  of
       0: begin
            bet[1,1]:=beta[1]*g2/pi2;
            bet[2,2]:=beta[2]*g2/pi2;
            bet[3,3]:=beta[3]*g2/pi2;
            bet[1,2]:=beta[4]*g2/pi2;
            bet[1,3]:=beta[5]*g2/pi2;
            bet[2,3]:=beta[6]*g2/pi2;
          end;
       1: begin
            bet[1,1]:=beta[1]*g2*ae*be;
            bet[2,2]:=beta[2]*g2*be*be;
            bet[3,3]:=beta[3]*g2*ce*ce;
            bet[1,2]:=beta[4]*g2*2*ae*be*cce;
            bet[1,3]:=beta[5]*g2*2*ae*ce*cbe;
            bet[2,3]:=beta[6]*g2*2*be*ce*cae;
          end;
        end;
        bet[2,1]:=bet[1,2];
        bet[3,1]:=bet[1,3];
        bet[3,2]:=bet[2,3];
     end;
   end;
   (*writeln(nomf,'beta Atome: ',child[iat].nom);
   for i:=1 to 3 do begin
     for j:=1 to 3 do write(nomf,bet[i,j]:10:6);
      writeln(nomf);
   end;*)
   mat_mult(bet,r12,aux);
  (*writeln(nomf,'aux');
   for i:=1 to 3 do begin
     for j:=1 to 3 do write(nomf,aux[i,j]:10:6);
     writeln(nomf);
   end;*)
   mat_mult(r12t,aux,mat);
   matinv(mat,mat_inv);
  (* writeln(nomf,'mat');
   for i:=1 to 3 do begin
     for j:=1 to 3 do write(nomf,mat[i,j]:10:6);
     writeln(nomf);
   end;
   writeln(nomf); *)
   diago(mat_inv,mat_vec_prop,val_prop);
   for i := 1 to 3 do  valeur_propre[iat,i]:=val_prop[i];
   for i := 1 to 3 do begin
     for j:=1 to 3 do begin
       vecteur_propre[iat,i,j]:=mat_vec_prop[i,j];
       b_quad[iat,i,j]:=mat_inv[i,j];
     end;
   end;
 end;
 //closefile(nomf);
 //fdessin.visible:=true;
end;


end.
