unit quel_bloc;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  Tfquel_bloc = class(TForm)
    ListBox1: TListBox;
    BitBtn1: TBitBtn;
    Memo1: TMemo;
    BitBtn2: TBitBtn;
    procedure init(Sender: TObject);
    procedure ok_select(Sender: TObject);
    procedure abort(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
  type block = record
    debut,fin,nb : integer;
    tit                : string;
  end;


var
  fquel_bloc              : Tfquel_bloc;
  bloc                    : array[1..10] of block;
  nb_blocs,numero_bloc    : integer;
implementation

{$R *.DFM}

uses
 licif2,oemath,mainmenu,paneau1;

procedure Tfquel_bloc.init(Sender: TObject);
//------------------------------------------
var
   i                  : integer;
   s                  : string;
begin
  listbox1.clear;
  if (nb_blocs > 0)then for i:=1 to nb_blocs do begin
    s:=bloc[i].tit;
    listbox1.Items.add(s);
    beep;
  end;
end;

procedure Tfquel_bloc.ok_select(Sender: TObject);
//-----------------------------------------------
var
  ier : integer;
begin
  numero_bloc:=listbox1.itemindex+1;
  ier:=0;
  lit_fichier_cif(ier);
  if (ier > 0)then begin
    close;
    exit;
  end;
  setmat;
  quel_systeme;
  set_typ_liaisons;

  with fmainmenu do begin
     label7.visible:=true;
     if (groupe_espace = '')then label7.caption:='No Space Group found'
     else label7.caption:='Space Group: '+groupe_espace;
     panel1.visible:=true;
     flag_modif_data:=1;
  end;
  ecrit_panel1;
  fquel_bloc.visible:=false;
end;

procedure Tfquel_bloc.abort(Sender: TObject);
//-------------------------------------------
begin
  close;
end;

end.
