unit digicode;

interface

Uses
  SysUtils, WinTypes, WinProcs,
  Controls, StdCtrls,  math,oemath;

var
  i1234               : array[1..5000,1..4] of integer;
  xorth,yorth,zorth   : array[1..5000] of double;

procedure set_code_positions;
procedure code_positions(var j,i1,i2,i3,i4 : integer);

implementation

procedure code_positions(var j,i1,i2,i3,i4: integer);
//--------------------------------------------------
  var
//  i,k,idgt,ix,iy,iz,no_motif              : integer;
    i,ix,iy,iz,no_motif                     : integer;
    x0,y0,z0,x1,y1,z1,x_at,y_at,z_at        : real;
    name,s                                  : string;
    //nomf                                    : textfile;
begin
  name:='';
  i1:=0;
  i2:=0;
  i3:=0;
  i4:=0;
  no_motif:=0;
  with child[j] do begin
    x_at:=x;
    y_at:=y;
    z_at:=z;
    s:=nom;traite_nom_atome(s);name:=uppercase(s);
  end;
  for i:=1 to nb_motif do begin
    with motif[i] do begin
      s:=nom;traite_nom_atome(s);s:=uppercase(s);
      if (name = s) then begin
        no_motif:=i;
        break;
      end;
    end;
  end;
  if (no_motif = 0)then begin
(*    assignfile(nomf,'espion.txt');
    rewrite(nomf);
    with(child[j]) do begin
      writeln(nomf,name:5,j:5,nom:5,x:8:5,y:8:5,z:8:5,element:4,labell:4);
    end;
    closefile(nomf);*)
    erreur(name+' not decoded');
    exit;
  end;
  for i:=1 to npos do begin
     with motif[no_motif] do begin
       x0:=tp[i,1,4]+x*tp[i,1,1]+y*tp[i,1,2]+z*tp[i,1,3];
       y0:=tp[i,2,4]+x*tp[i,2,1]+y*tp[i,2,2]+z*tp[i,2,3];
       z0:=tp[i,3,4]+x*tp[i,3,1]+y*tp[i,3,2]+z*tp[i,3,3];
     end;
     for ix:=-3 to 3 do begin
       for iy:=-3 to 3 do begin
         for iz:=-3 to 3 do begin
           x1:=x0+ix;
           y1:=y0+iy;
           z1:=z0+iz;
           if (abs(x1-x_at) < 0.001) and
              (abs(y1-y_at) < 0.001) and
              (abs(z1-z_at) < 0.001) then begin
             i1:=i;
             i2:=5+ix;
             i3:=5+iy;
             i4:=5+iz;
             exit;
           end;
         end;
       end;
     end;
  end;
end;

procedure set_code_positions;
//--------------------------
var
    k,i,i1,i2,i3,i4         : integer;
    x1,y1,z1                : double;
begin
  for i:=1 to nb_child do begin
    k:=i;
    code_positions(k,i1,i2,i3,i4);
    i1234[i,1]:=i1;
    i1234[i,2]:=i2;
    i1234[i,3]:=i3;
    i1234[i,4]:=i4;
    with child[i] do begin
      x1:=x;
      y1:=y;
      z1:=z;
      trfo2(x1,y1,z1,r20);
      xorth[i]:=x1;
      yorth[i]:=y1;
      zorth[i]:=z1;
    end;
  end;
end;

end.
