unit plan_moyen;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, math, Grids;

type
  Tfplan_moyen = class(TForm)
    ListBox1: TListBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    StringGrid1: TStringGrid;
    Label1: TLabel;
    Label2: TLabel;
    BitBtn16: TBitBtn;
    BitBtn4: TBitBtn;
    procedure sortie(Sender: TObject);
    procedure calcul(Sender: TObject);
    procedure edit_print(Sender: TObject);
    procedure peintgrid1(Sender: TObject; Col, Row: Integer; Rect: TRect;
      State: TGridDrawState);
    procedure affiche_coord(Sender: TObject);
    procedure souris_up(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure aide(Sender: TObject);
    procedure onselectcell(Sender: TObject; Col, Row: Integer;
      var CanSelect: Boolean);
    procedure init_crea(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fplan_moyen: Tfplan_moyen;
  no_plm                                      : array[1..30] of integer;
  nb_plm,nb_plan_moyen,no_bouton,ligne,colonne: integer;
  xn_plan_moyen,yn_plan_moyen,zn_plan_moyen   : array[1..30]of double;
  no_plan_moyen                               : array[1..30,1..30] of integer;
  pop_plan_moyen                              : array[1..30] of integer;
  coef_plan                                   : array[1..3,1..30] of double;
  nomf                                        : Textfile;

implementation

{$R *.DFM}
uses
  //stdhdr,matmath,oemath;
  oemath, dessin, disp_coord2;

{---DLL -----------------------------------------------------------------------}
procedure plan;
                   far;stdcall;external 'plan.dll' index 1;
{------------------------------------------------------------------------------}

procedure Tfplan_moyen.sortie(Sender: TObject);
//---------------------------------------------
var
  i,j   : integer;
begin
  nb_plm:=0;
  nb_plan_moyen:=0;
  listbox1.clear;
  flag_plan_moyen:=0;
  fplan_moyen.hide;
  fplan_moyen.visible:=false;
  with stringGrid1 do begin
    for i:=0 to rowcount-1 do
    for j:=0 to colcount-1 do
    cells[j,i]:='';
  end;
 (* for i:=1 to nb_child do begin
    child[i]:=child_init[i];
    child_old[i]:=child[i];
  end;
  with fdessin do begin
    checkbox7.checked:=cb7_check_old;
    checkbox4.checked:=cb4_check_old;
  end; *)
  reset_config_labels;
  fdessin.masque_panel2(sender);
  dessine;
end;

procedure relit_Grid1;
//--------------------
var
  s                        : string;
  i,j                      : integer;
begin
  nb_plan_moyen:=0;
  with fplan_moyen.StringGrid1 do begin
    for i:=0 to rowcount-1 do begin
       s:=cells[0,i];
       if (s = '')then break;
       nb_plan_moyen:=nb_plan_moyen+1;
       pop_plan_moyen[i+1]:=0;
       for j:=1 to colcount-1 do begin
         s:=cells[j,i];
         if (s = '')then break;
         delete(s,1,pos('(',s));
         delete(s,pos(')',s),1);
         pop_plan_moyen[i+1]:=pop_plan_moyen[i+1]+1;
         no_plan_moyen[i+1,pop_plan_moyen[i+1]]:=strToInt(s);
       end;
    end;
  end;
end;

procedure Tfplan_moyen.calcul(Sender: TObject);
//---------------------------------------------
var
  i,j,k                  : integer;
  //phi                    : recmat;
  //y                      : longvector;
  //l,m                    : integer;
  //coef                   : longvector;
  s,s1                   : string;
  //t,d,dp,c0,c1,c2,den    : double;
  //xn,yn,zn               : double;
  xx,yy,zz               : array[1..30] of double;
  nam                    : array[1..30] of string[4];
  nomf                   : textfile;
  mat,mat2               : matrice3;
  w                      : word;
begin

  relit_grid1;
  if (nb_plan_moyen  = 0)then exit;

//Le dernier plan moyen ne contient qu'un ou deux atomes
  for i:=1 to nb_plan_moyen do begin
    if(pop_plan_moyen[i] <  3)then begin
        beep;
        erreur('Selected atoms number < 3!');
        nb_plan_moyen:=nb_plan_moyen-1;
        exit;
    end;
  end;

//Ecriture dans le fichier PLAN.DAT
  assignfile(nomf,repertoire_origine+'/plan.dat');
  rewrite(nomf);

//Ecriture titre
  writeln(nomf,extractFileName(nom_fichier_shelx));

  //Ecriture maille
  for i:=1 to 6 do write(nomf,cel[i]:10:3);
  writeln(nomf);

//Ecriture coordonnes
  writeln(nomf,nb_child:4);
  for i:=1 to nb_child do begin
     with child[i] do begin
       s:=nom;
       for  k:=length(s)+1 to 5 do s:=s+' ';
       writeln(nomf,s,x:10:4,y:10:4,z:10:4);
     end;
  end;

//Ecriture des plans
  for i:=1 to nb_plan_moyen do begin
    write(nomf,pop_plan_moyen[i]:5);
    for j:=1 to pop_plan_moyen[i] do write(nomf,no_plan_moyen[i,j]:5);
    writeln(nomf);
  end;
  closefile(nomf);

//lancement de la DLL
  plan;

//Rcupration des rsultats
  assignfile(nomf,repertoire_origine+'/plan.sor');
  reset(nomf);

//diagnostic=derniere ligne
  while not(eof(nomf)) do  readln(nomf,s1);
  closefile(nomf);

  screen.cursor:=crDefault;
  //showMessage(s1);
  if (pos('Normal end',s1) > 0)then begin
    assignfile(nomf,repertoire_origine+'/plan.sor');
    reset(nomf);
    listbox1.clear;
    str(nb_plan_moyen:2,s1);
    s:='Plane Nb.'+s1+':';
    s1:='';
    while (pos(s,s1) = 0)do begin
      readln(nomf,s1);
    end;
    k:=0;
    listbox1.items.add(s1);
    k:=k+1;
    while not(eof(nomf)) do begin
      readln(nomf,s1);
      listbox1.items.add(s1);
      k:=k+1;
    end;
    listbox1.itemindex:=k-1;
    closefile(nomf);
    beep;
  end else begin
    beep;
    //nb_plm:=0;
    if (pos('aligned',s1) > 0) then begin
      w:=messageDlg(trim(s1)+'. Do you want to continue?',
      mtConfirmation,mbYesNoCancel,0);
      if (w = mrNo) or (w = mrAbort) then begin
        //Effacement de toute la ligne
        for i:=0 to stringGrid1.colcount-1 do stringGrid1.cells[i,nb_plan_moyen-1]:='';
        nb_plan_moyen:=nb_plan_moyen-1;
        nb_plm:=0;
      end else begin
        nb_plan_moyen:=nb_plan_moyen-1;
        exit;
      end;
    end else begin
      nb_plm:=0;
      exit;
    end;
  end;
  nb_plm:=0;
  dessine;

end;

procedure Tfplan_moyen.edit_print(Sender: TObject);
//------------------------------------------------
var
  //nomf                                        : Textfile;
  i,j,k                                       : integer;
 // t,den,xx,yy,zz,dp,c0,c1,c2                  : double;
  s,s1                                        : string;
  cmdfile                                     : Pchar;
begin
   if (FileExists('plan.sor') = false)then exit;
   CmdFile:='write.exe plan.sor';
   i:=WinExec(CmdFile,5);
end;

procedure Tfplan_moyen.peintgrid1(Sender: TObject; Col, Row: Integer;
  Rect: TRect; State: TGridDrawState);
//--------------------------------------------------------------
var
  s           : string;
  posx        : integer;
begin
  with stringGrid1.canvas do begin
    s:=stringGrid1.cells[col,row];
    posx:= ((Rect.right-rect.left-2)-textWidth(s)) div 2;
    textrect(rect,rect.left+posx,rect.top,s);
  end;
end;

procedure Tfplan_moyen.affiche_coord(Sender: TObject);
//----------------------------------------------------
begin
  fdisp_coord.show;
end;

procedure Tfplan_moyen.souris_up(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
//-----------------------------------------------------------------------
var
  i,j,k,ier            : integer;
  s                    : string;
begin
  colonne:= x div StringGrid1.DefaultColWidth;
  ligne  := y div StringGrid1.DefaultRowHeight;
    with StringGrid1 do begin
      if(colonne = 0) then begin
        //Effacement de toute la ligne
        for i:=0 to colcount-1 do cells[i,ligne]:='';
        if (ligne < nb_plan_moyen) then begin
          for j:= ligne to nb_plan_moyen-1 do
          for k:=0 to colcount-1 do cells[k,ligne]:=cells[k,ligne+1];
          for k:=0 to colcount-1 do cells[k,nb_plan_moyen-1]:='';
        end;
        relit_grid1;
        dessine;
        //nb_plm:=0;
      end else begin
        //Effacement d'un atome
        cells[colonne,ligne]:='';
        if (colonne <= nb_plm)then
        for i:=colonne to  nb_plm-1 do begin
          Cells[i,ligne]:=cells[i+1,ligne];
          //Correction du tableau no_plm
           no_plm[i]:=no_plm[i+1];
        end;
        nb_plm:=nb_plm-1;
        //On trace les noms des atomes slectionns
        trace_atomes_plans;
      end;
    end;
end;

procedure Tfplan_moyen.aide(Sender: TObject);
//-------------------------------------------
begin
   Application.HelpContext(11);
end;

procedure Tfplan_moyen.onselectcell(Sender: TObject; Col, Row: Integer;
  var CanSelect: Boolean);
//-----------------------------------------------------------------------
var
  i,j,k,ier            : integer;
  s                    : string;
begin
    colonne:= col;
    ligne  := row;
    with StringGrid1 do begin
      if(colonne = 0) then begin
        //Effacement de toute la ligne
        for i:=0 to colcount-1 do cells[i,ligne]:='';
        if (ligne < nb_plan_moyen) then begin
          for j:= ligne to nb_plan_moyen-1 do
          for k:=0 to colcount-1 do cells[k,ligne]:=cells[k,ligne+1];
          for k:=0 to colcount-1 do cells[k,nb_plan_moyen-1]:='';
        end;
        //Correction du tableau no_plan_moyen[1..pop_plan_moyen](suppression d'une ligne)
        relit_grid1;
        //Renumrotation
        for i:=0 to nb_plan_moyen-1 do cells[0,i]:='Nb.'+inttostr(i+1);
        dessine;
        nb_plm:=0;
      end else begin
        //Effacement d'un atome
        if (nb_plm = 0)then exit;
        cells[colonne,ligne]:='';
        if (colonne <= nb_plm)then
        for i:=colonne to  nb_plm-1 do begin
          Cells[i,ligne]:=cells[i+1,ligne];
          //Correction du tableau no_plm
           no_plm[i]:=no_plm[i+1];
        end;
        cells[nb_plm,ligne]:='';
        nb_plm:=nb_plm-1;
        //On trace les noms des atomes slectionns
        trace_atomes_plans;
      end;
    end;
  end;

procedure Tfplan_moyen.init_crea(Sender: TObject);
//------------------------------------------------
begin

if (screen.Width = 800)then begin
    with fplan_moyen do begin
    Left := 475;
    Top := 0;
    width:=323;
    height:=570;
  end;;
  with Label1 do begin
    Left := 96;
    Top := 36;
    Width := 114;
    Height := 16;
  end;
  with Label2 do begin
    Left := 136 ;
    Top := 180 ;
    Width := 53 ;
    Height := 16 ;
  end;
  with ListBox1 do begin
    Left := 1;
    Top := 197;
    Width := 313 ;
    Height := 345 ;
  end;
  with BitBtn1 do begin
    Left := 128  ;
    Top := 0;
    Width := 32 ;
    Height := 32;
  end;
  with BitBtn2 do begin
    Left := 64 ;
    Top := 0;
    Width := 32 ;
    Height := 32;
  end;
  with BitBtn3 do begin
    Left := 96;
    Top := 0;
    Width := 32;
    Height := 32 ;
  end;
  with StringGrid1 do begin
    Left := 0;
    Top := 56 ;
    Width := 313;
    Height := 121 ;
  end;
  with BitBtn16 do begin
    Left := 32;
    Top := 0 ;
    Width := 32;
    Height := 32 ;
  end;
  with BitBtn4 do begin
    Left := 0;
    Top := 0;
    Width := 32;
    Height := 32;
  end;
end;
end;

end.
