unit sphere;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  Tfsphere = class(TForm)
    Panel2: TPanel;
    Label7: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    ListBox1: TListBox;
    Edit7: TEdit;
    Edit8: TEdit;
    Edit9: TEdit;
    Label1: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Button2: TButton;
    RadioGroup1: TRadioGroup;
    Memo1: TMemo;
    procedure clic_listbox1(Sender: TObject);
    procedure initialise(Sender: TObject);
    procedure annule(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure attention(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fsphere: Tfsphere;
//  flag_sphere:boolean;

implementation

{$R *.DFM}

uses
  oemath;

procedure Tfsphere.clic_listbox1(Sender: TObject);
//----------------------------------------------
var
  s,s1                 : string;
begin
  s:=ListBox1.items[listbox1.itemIndex];
  delete(s,1,5);
  s:=trim(s);
  s1:=copy(s,1,pos(' ',s));
  edit7.text:=' '+trim(s1);
  delete(s,1,pos(' ',s));
  s:=trim(s);
  s1:=copy(s,1,pos(' ',s));
  edit8.text:=' '+trim(s1);
  delete(s,1,pos(' ',s));
  edit9.text:=' '+trim(s);
end;

procedure Tfsphere.initialise(Sender: TObject);
//-------------------------------------------
var
   s,s1          : string;
   i             : integer;
begin
  if (radiogroup1.itemIndex =1)then memo1.visible:=true
  else memo1.visible:=false;
  listbox1.clear;
  str(rayon_sphere:6:3,s);edit1.text:=s;
  str(x_centre:7:4,s);edit7.text:=s;
  str(y_centre:7:4,s);edit8.text:=s;
  str(z_centre:7:4,s);edit9.text:=s;
  for i:=1 to nb_motif do begin
    with motif[i] do begin
      s:=nom+' ';
      str(x:9:4,s1);
      s:=s+s1;
      str(y:8:4,s1);
      s:=s+s1;
      str(z:8:4,s1);
      s:=s+s1;
      listbox1.items.add(s);
    end;
  end;
end;

procedure Tfsphere.annule(Sender: TObject);
//-----------------------------------------------
begin
  flag_sphere:=0;
  fsphere.visible:=false;
end;

procedure Tfsphere.Button1Click(Sender: TObject);
//----------------------------------------------
var
  ier    : integer;
  s      : string;
begin
  ier:=0;

//Rayon
  if(edit1.text = '')then edit1.text:='0';
  val(edit1.text,rayon_sphere,ier);
  if(ier <> 0)then begin
    beep;
    edit1.setfocus;
    exit;
  end;

//Centre
  if(edit7.text = '')then edit7.text:='0';
  s:=edit7.text;
  val(s,x_centre,ier);
  if(ier <> 0)then begin
    beep;
    edit7.setfocus;
    exit;
  end;
  if(edit8.text = '')then edit8.text:='0';
  val(edit8.text,y_centre,ier);
  if(ier <> 0)then begin
    beep;
    edit8.setfocus;
    exit;
  end;
  if(edit9.text = '')then edit9.text:='0';
  val(edit9.text,z_centre,ier);
  if(ier <> 0)then begin
    beep;
    edit9.setfocus;
    exit;
  end;
  case radiogroup1.ItemIndex of      //On garde les fragments entiers?
    0: begin
         flag_cut_sphere:=1;
       end;
    1: begin
         flag_cut_sphere:=0;
       end;
  end;
  fsphere.visible:=false;

end;

procedure Tfsphere.attention(Sender: TObject);
begin
  if (radiogroup1.itemIndex =1)then memo1.visible:=true
  else memo1.visible:=false;
end;

end.
